/*
 * write your skin finding code in this file.  when executed, it
 * should read in a PPM image and write the same image, but with
 * skin pixels somehow visually identified (highlighted, or 
 * colored red, etc.).  you may also want to read in the parameters
 * of your skin finder, so you don't have to hard code them.  how 
 * exactly you represent skin is up to you.  you may also want to
 * convert the RGB color values to a different format.
 */

#include "port.h"

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

void write_ppm( FILE* f, int width, int height, unsigned char* data );
unsigned char* read_ppm( char* filename, int* width, int* height );

#define I(x,y,c)   (input_image[3*((y)*(width)+(x))+(c)])
#define O(x,y,c)   (output_image[3*((y)*(width)+(x))+(c)])
#define C(i,j)     (cov[(i)*(d)+(j)])

main( int argc, char **argv )
{
     int width, height;
     unsigned char* input_image;
	 unsigned char* output_image;
          
	 // write your code here.  you may also add functions
	 // outside of main if you wish.

     write_ppm( stdout, width, height, output_image );
}

unsigned char* read_ppm( char* filename, int* width, int* height )
{
     char buffer[80];
     int phase = 0;
     int type, maxval;
     int j;
     unsigned char* data;
     FILE* f;

     if ( strcmp( filename, "-" ) == 0 )
     {
	  f = stdin;
     }
     else
     {
	  f = fopen( filename, "rb" );
	  if ( f == NULL )
	       return NULL;
     }
     
     while ( phase < 4 )
     {
	  fgets( buffer, 80, f );
	  if ( buffer[0] == '#' ) continue;
	  switch( phase )
	  {
	     case 0: j = sscanf( buffer, "P%d %d %d %d\n", &type, width, height, &maxval ); break;
	     case 1: j = sscanf( buffer, "%d %d %d\n", width, height, &maxval ); break;
	     case 2: j = sscanf( buffer, "%d %d\n", height, &maxval ); break;
	     case 3: j = sscanf( buffer, "%d\n", &maxval ); break;
	     case 4: j = 0; break;
	  }
	  phase += j;
     }

     if ( type != 6 )
     {
	  fprintf( stderr, "bad input image format.\n" );
	  return NULL;
     }

     data = (unsigned char*)malloc ( *width * *height * 3 );
     fread( data, *width * *height * 3, 1, f );

     fclose( f );
     
     return data;
}

void write_ppm( FILE* f, int width, int height, unsigned char* data )
{
     fprintf( f, "P6\n%d %d\n%d\n", width, height, 255 );
     fwrite( data, width*height*3, 1, f );
     fclose( f );
}
