/*
 * write your k-means code in this file.  when executed, it should
 * read in a PPM image and and write a PGM image where each pixel's
 * intensity value is its cluster label.  you might want to read in
 * other data, like the number of clusters, and you might want to 
 * output some extra information about each cluster (for example,
 * its mean color).  you could also try transforming the input image
 * to a different color space before running k-means.
 */

#include "port.h"

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

void write_pgm( FILE* f, int width, int height, unsigned char* data );
unsigned char* read_ppm( char* filename, int* width, int* height );

#define I(x,y,c)   (input_image[3*((y)*(width)+(x))+(c)])
#define O(x,y)     (output_image[(y)*(width)+(x)])

main( int argc, char **argv )
{
     int width, height;
     unsigned char* input_image;
	 unsigned char* output_image;     
     
	 // write your code here.  you may also add functions
	 // outside of main if you wish.

     write_pgm( stdout, width, height, output_image );
}

unsigned char* read_ppm( char* filename, int* width, int* height )
{
     char buffer[80];
     int phase = 0;
     int type, maxval;
     int j;
     unsigned char* data;
     FILE* f;

     if ( strcmp( filename, "-" ) == 0 )
     {
	  f = stdin;
     }
     else
     {
	  f = fopen( filename, "rb" );
	  if ( f == NULL )
	       return NULL;
     }
     
     while ( phase < 4 )
     {
	  fgets( buffer, 80, f );
	  if ( buffer[0] == '#' ) continue;
	  switch( phase )
	  {
	     case 0: j = sscanf( buffer, "P%d %d %d %d\n", &type, width, height, &maxval ); break;
	     case 1: j = sscanf( buffer, "%d %d %d\n", width, height, &maxval ); break;
	     case 2: j = sscanf( buffer, "%d %d\n", height, &maxval ); break;
	     case 3: j = sscanf( buffer, "%d\n", &maxval ); break;
	     case 4: j = 0; break;
	  }
	  phase += j;
     }

     if ( type != 6 )
     {
	  fprintf( stderr, "bad input image format.\n" );
	  return NULL;
     }

     data = (unsigned char*)malloc ( *width * *height * 3 );
     fread( data, *width * *height * 3, 1, f );

     fclose( f );
     
     return data;
}

void write_pgm( FILE* f, int width, int height, unsigned char* data )
{
     fprintf( f, "P5\n%d %d\n%d\n", width, height, 255 );
     fwrite( data, width*height, 1, f );
     fclose( f );
}
